#include "kclipboard.h"
#include <stdlib.h>

void	KClipboard::setData(const char* format,void *data,int len)
{
	void	*out;

	encode(data,len,&out);

	if(out)
	{
		QClipboard::setData(format,out);
		free(out);
	}
}
void	*KClipboard::data(const char* format,int *len)
{
	void	*out,*data;

	data = QClipboard::data(format);

	if(data)
	{
		*len = decode(data,&out);

		return out;
	}

	return NULL;
}

void	KClipboard::encode(void *datain,int len,void **dataout)
{
	int		nlen = len + (len + 6) / 7;
	int		t,i,r;
	unsigned char	*in,*out;

	if((*dataout = malloc(nlen)) == NULL)
	{
		return;
	}

	in = (unsigned char*)datain;
	out = *(unsigned char**)dataout;

	for(t = 0;t < len / 7;t++)
	{
		out[t * 8 + 7] = 128;
		for(i = 0;i < 7;i++)
		{
			out[t * 8 + 7] |= (in[t * 7 + i] & 128) >> (7 - i);
			out[t * 8 + i] = (in[t * 7 + i] & 127) + 1;
		}
	}
	r = len % 7;
	out[t * 8 + r] = 128;
	for(i = 0;i < r;i++)
	{
		out[t * 8 + r] |= (in[t * 7 + i] & 128) >> (7 - i);
		out[t * 8 + i] = (in[t * 7 + i] & 127) + 1;
	}
}

int	KClipboard::decode(void *datain,void **dataout)
{
	int		len = strlen((char*)datain);
	int		nlen = len - (len + 7) / 8;
	int		t,i,r;
	unsigned char	c,*in,*out;

	if((*dataout = malloc(nlen)) == NULL)
	{
		return 0;
	}

	in = (unsigned char*)datain;
	out = *(unsigned char**)dataout;

	for(t = 0;t < nlen / 7;t++)
	{
		for(i = 0;i < 7;i++)
		{
			// (in[t * 7 + i] & 128) >> (7 - i);
			c = (in[t * 8 + 7] << (7 - i)) & 128;
			// (in[t * 7 + i] & 127) + 1;
			c |= in[t * 8 + i] - 1;
			out[t * 7 + i] = c;
		}
	}
	r = nlen % 7;
	for(i = 0;i < r;i++)
	{
		c = (in[t * 8 + r] << (7 - i)) & 128;
		c |= in[t * 8 + i] - 1;
		out[t * 7 + i] = c;
	}

	return nlen;
}

#ifdef TEST_CODING

void	main(void)
{
	char	array[20] = {0,1,2,126,127,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0};
	char	*en,*de;
	int	t,l;

	for(t = 0;t < 20;t++)
		printf("Array #%i: %i\n",t,array[t]);

	tencode(array,20,&en);

	for(t = 0;t < 20;t++)
		printf("Array #%i: %i\n",t,en[t]);

	l = tdecode(en,&de);

	for(t = 0;t < l;t++)
		printf("Array #%i: %i\n",t,de[t]);

}

#endif
